package org.bdware.server.permission.test;

import org.bdware.server.permission.Permission;

import java.util.EnumSet;

import static org.bdware.server.permission.Permission.*;

public class PermissionTest {
    public static void main(String[] args) {
        EnumSet<Permission> setCenterManager = EnumSet.noneOf(Permission.class);
        // 为了便于生成五种角色的Permission 可以用一串set.add()。然后打印出来。
        // 中心管理员
        setCenterManager.add(ApplyRole);
        setCenterManager.add(NodeStateList);
        setCenterManager.add(AuthNodeManager);
        setCenterManager.add(ListAllUsers);
        setCenterManager.add(ListApplyUser);
        setCenterManager.add(DeleteNodeManager);
        setCenterManager.add(ListTrustCluster);
        setCenterManager.add(AssignTrustedCluster);
        setCenterManager.add(QueryActionLog);// 增加listLog(时间戳)
        setCenterManager.add(QueryUserStateLog);// 查看节点日志
        long CenterManager = 0L;
        for (Permission p : setCenterManager) {
            CenterManager |= p.getValue();
        }
        System.out.println("[centerManager]" + String.format("0x%xL", CenterManager));
        EnumSet<Permission> setNodeManager = EnumSet.noneOf(Permission.class);
        // 节点管理员
        setNodeManager.add(ApplyRole);
        setNodeManager.add(ListTrustCluster);
        setNodeManager.add(QueryUserStateLog);
        setNodeManager.add(ConfigureNode);
        setNodeManager.add(ManageNode);
        setNodeManager.add(GetNodeInfo);
        setCenterManager.add(TakeScreenShot);
        long NodeManager = 0L;//2248150849
        for (Permission p : setNodeManager) {
            NodeManager |= p.getValue();
        }
        System.out.println("[NodeManager]" + String.format("0x%xL", NodeManager) + " " + NodeManager);

        EnumSet<Permission> setContractProvider = EnumSet.noneOf(Permission.class);
        // 合约提供者
        setContractProvider.add(ContractCodeStatisticsList);
        setContractProvider.add(ConfigureContractPermission);
        setContractProvider.add(EditContract);
        setContractProvider.add(ListProject);
        setContractProvider.add(StaticAnalysis);
        setContractProvider.add(Compile);
        long ContractProvider = 0L;
        for (Permission p : setContractProvider) {
            ContractProvider |= p.getValue();
        }
        System.out.println("[ContractProvider]" + String.format("0x%xL", ContractProvider));
        EnumSet<Permission> ContractInstanceManager = EnumSet.noneOf(Permission.class);
        // 合约管理者
        ContractInstanceManager.add(AssignTrustedCluster);
        ContractInstanceManager.add(ListTrustCluster);
        ContractInstanceManager.add(ContractCodeStatisticsList);
        ContractInstanceManager.add(StaticAnalysis);
        ContractInstanceManager.add(ContractPermissionList);
        ContractInstanceManager.add(ListContractProgress);
        ContractInstanceManager.add(CheckContractStatus);
        ContractInstanceManager.add(ListContractLog);
        ContractInstanceManager.add(TimeTravel);
        ContractInstanceManager.add(ManualDump);
        ContractInstanceManager.add(ManageMemory);
        ContractInstanceManager.add(ManageContract);
        ContractInstanceManager.add(CreateLedger);
        ContractInstanceManager.add(Compile);
        long ContractInstanceManagerVAL = 0L;
        for (Permission p : ContractInstanceManager) {
            ContractInstanceManagerVAL |= p.getValue();
        }
        System.out.println("[ContractInstanceManager]" + String.format("0x%xL", ContractInstanceManagerVAL));

        EnumSet<Permission> ContractUser = EnumSet.noneOf(Permission.class);
        // 合约使用者
        ContractUser.add(ListContractProgress);
        ContractUser.add(ContractPermissionList);
        ContractUser.add(CheckContractStatus);
        ContractUser.add(ListContractLog);
        long ContractUserVAL = 0L;
        for (Permission p : ContractUser) {
            ContractUserVAL |= p.getValue();
        }
        System.out.println("[ContractUser]" + String.format("0x%xL", ContractUserVAL));
    }
}
